declare type ZodErrorArray = {
    path: (string | number)[];
    message: string;
}[];
export declare class ZodError extends Error {
    errors: ZodErrorArray;
    constructor();
    static create: (errors: {
        path: (string | number)[];
        message: string;
    }[]) => ZodError;
    readonly message: string;
    readonly empty: boolean;
    static fromString: (message: string) => ZodError;
    mergeChild: (pathElement: string | number, child: Error) => void;
    bubbleUp: (pathElement: string | number) => ZodError;
    addError: (path: string | number, message: string) => void;
    merge: (error: ZodError) => void;
}
export {};
