"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var z = __importStar(require("./types/base"));
var ZodError_1 = require("./ZodError");
var util_1 = require("./helpers/util");
exports.ZodParser = function (schemaDef) { return function (obj, params) {
    if (params === void 0) { params = { seen: [] }; }
    var def = schemaDef;
    // const { seen } = params;
    // const y:ZodObject<any> = "asdf" as any;
    // console.log(`visit ${schemaDef.t}: ${typeof obj} - ${obj.name || ''}`);
    // if (!['number', 'string', 'boolean', 'undefined'].includes(typeof obj)) {
    var schemaSeen = params.seen.find(function (x) { return x.schema === schemaDef; });
    if (schemaSeen) {
        if (schemaSeen.objects.indexOf(obj) !== -1) {
            // console.log(`seen ${typeof obj} before: ${obj.name}`);
            return obj;
        }
        else {
            schemaSeen.objects.push(obj);
        }
    }
    else {
        params.seen.push({ schema: schemaDef, objects: [obj] });
    }
    // }
    switch (def.t) {
        case z.ZodTypes.string:
            if (typeof obj !== 'string')
                throw ZodError_1.ZodError.fromString("Non-string type: " + typeof obj);
            // return obj as any;
            break;
        case z.ZodTypes.number:
            if (typeof obj !== 'number')
                throw ZodError_1.ZodError.fromString("Non-number type: " + typeof obj);
            if (Number.isNaN(obj)) {
                throw ZodError_1.ZodError.fromString("Non-number type: NaN");
            }
            // return obj as any;
            break;
        case z.ZodTypes.bigint:
            if (typeof obj !== 'bigint') {
                throw ZodError_1.ZodError.fromString("Non-bigint type: " + typeof obj + ".");
            }
            // return obj;
            break;
        case z.ZodTypes.boolean:
            if (typeof obj !== 'boolean')
                throw ZodError_1.ZodError.fromString("Non-boolean type: " + typeof obj);
            // return obj as any;
            break;
        case z.ZodTypes.undefined:
            if (obj !== undefined)
                throw ZodError_1.ZodError.fromString("Non-undefined type:Found: " + typeof obj);
            // return undefined;
            break;
        case z.ZodTypes.null:
            if (obj !== null)
                throw ZodError_1.ZodError.fromString("Non-null type: " + typeof obj);
            break;
        case z.ZodTypes.any:
            break;
        case z.ZodTypes.unknown:
            break;
        case z.ZodTypes.array:
            if (!Array.isArray(obj))
                throw ZodError_1.ZodError.fromString("Non-array type: " + typeof obj);
            var arrayError_1 = ZodError_1.ZodError.create([]);
            if (def.nonempty === true && obj.length === 0) {
                throw ZodError_1.ZodError.fromString('Array cannot be empty');
            }
            obj.map(function (item, i) {
                try {
                    var parsedItem = def.type.parse(item, params);
                    return parsedItem;
                }
                catch (err) {
                    arrayError_1.mergeChild(i, err);
                }
            });
            if (!arrayError_1.empty) {
                // throw ZodError.fromString(arrayErrors.join('\n\n'));
                throw arrayError_1;
            }
            break;
        // return parsedArray as any;
        case z.ZodTypes.object:
            if (typeof obj !== 'object')
                throw ZodError_1.ZodError.fromString("Non-object type: " + typeof obj);
            if (Array.isArray(obj))
                throw ZodError_1.ZodError.fromString("Non-object type: array");
            var shape = def.shape;
            if (def.params.strict) {
                var shapeKeys_1 = Object.keys(def.shape);
                var objKeys = Object.keys(obj);
                var extraKeys = objKeys.filter(function (k) { return shapeKeys_1.indexOf(k) === -1; });
                if (extraKeys.length) {
                    // console.log(def);
                    throw ZodError_1.ZodError.fromString("Unexpected key(s) in object: " + extraKeys.map(function (k) { return "'" + k + "'"; }).join(', '));
                }
            }
            var parsedObject = {};
            var objectError = ZodError_1.ZodError.create([]);
            for (var key in shape) {
                try {
                    var parsedEntry = def.shape[key].parse(obj[key], params);
                    parsedObject[key] = parsedEntry;
                }
                catch (err) {
                    objectError.mergeChild(key, err);
                }
            }
            if (!objectError.empty) {
                throw objectError; //ZodError.fromString(objectErrors.join('\n'));
            }
            // return parsedObject;
            break;
        case z.ZodTypes.union:
            var isValid = false;
            var unionErrors = [];
            // unionError.addError('union', 'Error parsing union type.');
            for (var _i = 0, _a = def.options; _i < _a.length; _i++) {
                var option = _a[_i];
                try {
                    option.parse(obj, params);
                    isValid = true;
                }
                catch (err) {
                    unionErrors.push("\tunion option #" + def.options.indexOf(option) + ": " + err.message);
                    // isValid = false;
                }
            }
            if (isValid === false) {
                throw ZodError_1.ZodError.fromString('\n' + unionErrors.join('\n'));
                // throw ZodError.fromString(
                //   `Error parsing union.\nReceived: ${JSON.stringify(obj, null, 2)}\nExpected: ${def.options
                //     .map(x => x._def.t)
                //     .join(' OR ')}`,
                // );
            }
            break;
        case z.ZodTypes.intersection:
            var errors = [];
            try {
                def.left.parse(obj, params);
            }
            catch (err) {
                errors.push("Left side of intersection: " + err.message);
            }
            try {
                def.right.parse(obj, params);
            }
            catch (err) {
                errors.push("Right side of intersection: " + err.message);
            }
            if (errors.length) {
                throw ZodError_1.ZodError.fromString(errors.join('\n'));
            }
            break;
        case z.ZodTypes.tuple:
            if (!Array.isArray(obj)) {
                // tupleError.addError('','Non-array type detected; invalid tuple.')
                throw ZodError_1.ZodError.fromString('Non-array type detected; invalid tuple.');
            }
            if (def.items.length !== obj.length) {
                // tupleError.addError('',`Incorrect number of elements in tuple: expected ${def.items.length}, got ${obj.length}`)
                throw ZodError_1.ZodError.fromString("Incorrect number of elements in tuple: expected " + def.items.length + ", got " + obj.length);
            }
            var tupleError = ZodError_1.ZodError.create([]);
            var parsedTuple = [];
            for (var index in obj) {
                var item = obj[index];
                var itemParser = def.items[index];
                try {
                    parsedTuple.push(itemParser.parse(item, params));
                }
                catch (err) {
                    console.log("mering child: " + index);
                    tupleError.mergeChild(index, err);
                }
            }
            if (!tupleError.empty) {
                throw tupleError;
            }
            // return parsedTuple as any;
            break;
        case z.ZodTypes.lazy:
            var lazySchema = def.getter();
            lazySchema.parse(obj, params);
            // return lazySchema.parse(obj, params);
            break;
        // return obj;
        case z.ZodTypes.literal:
            // const literalValue = def.value;
            // if (typeof literalValue === 'object' && obj !== null) throw ZodError.fromString(`Can't process non-primitive literals.`);
            // if (['string','']typeof obj === 'object') throw ZodError.fromString(`Invalid type: ${object}.`);
            if (obj !== def.value)
                throw ZodError_1.ZodError.fromString(obj + " !== " + def.value);
            break;
        case z.ZodTypes.enum:
            if (def.values.indexOf(obj) === -1) {
                throw ZodError_1.ZodError.fromString("\"" + obj + "\" does not match any value in enum");
            }
            // return obj;
            break;
        case z.ZodTypes.function:
            if (typeof obj !== 'function') {
                throw ZodError_1.ZodError.fromString("Non-function type: \"" + typeof obj + "\"");
            }
            var validatedFunc = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                try {
                    def.args.parse(args);
                    var result = obj.apply(void 0, args);
                    def.returns.parse(result);
                    return result;
                }
                catch (err) {
                    throw err;
                }
            };
            return validatedFunc;
        // return obj;
        case z.ZodTypes.record:
            if (typeof obj !== 'object')
                throw ZodError_1.ZodError.fromString("Non-object type: " + typeof obj);
            if (Array.isArray(obj))
                throw ZodError_1.ZodError.fromString("Non-object type: array");
            var parsedRecord = {};
            var recordError = new ZodError_1.ZodError();
            for (var key in obj) {
                try {
                    parsedRecord[key] = def.valueType.parse(obj[key]);
                }
                catch (err) {
                    recordError.mergeChild(key, err);
                }
            }
            if (!recordError.empty)
                throw recordError;
            // return parsedRecord;
            break;
        case z.ZodTypes.date:
            if (obj instanceof Date) {
                if (isNaN(obj.getTime())) {
                    // return obj;
                    // } else {
                    throw ZodError_1.ZodError.fromString("Invalid date.");
                }
            }
            else {
                throw ZodError_1.ZodError.fromString("Non-Date type: " + typeof obj);
            }
            break;
        case z.ZodTypes.promise:
            if (!obj.then || typeof obj.then !== 'function') {
                console.log(JSON.stringify(obj, null, 2));
                throw ZodError_1.ZodError.fromString("Non-Promise type: " + typeof obj);
            }
            if (!obj.catch || typeof obj.catch !== 'function') {
                console.log(JSON.stringify(obj, null, 2));
                throw ZodError_1.ZodError.fromString("Non-Promise type: " + typeof obj);
            }
            // if (util.getObjectType(obj) !== 'Promise') {
            //   throw ZodError.fromString(`Non-Promise type.`);
            // }
            if (def.checks) {
                throw ZodError_1.ZodError.fromString("Can't apply custom validators to Promise schemas.");
            }
            return new Promise(function (res, rej) { return __awaiter(_this, void 0, void 0, function () {
                var objValue, parsed;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, obj];
                        case 1:
                            objValue = _a.sent();
                            try {
                                parsed = def.type.parse(objValue);
                                res(parsed);
                            }
                            catch (err) {
                                rej(err);
                            }
                            return [2 /*return*/];
                    }
                });
            }); });
        default:
            // function
            // return obj;
            util_1.util.assertNever(def);
        // break;
    }
    var customChecks = def.checks || [];
    for (var _b = 0, customChecks_1 = customChecks; _b < customChecks_1.length; _b++) {
        var check = customChecks_1[_b];
        if (check.check(obj) !== true) {
            throw ZodError_1.ZodError.fromString(check.message || "Failed custom check.");
        }
    }
    return obj;
    // assertNever();
    // return obj;
}; };
//# sourceMappingURL=parser.js.map